;; sawmx-flipped/theme.jl

;; Copyright (C) 1999 Michele Campeotto <micampe@f2s.com>

(let* (
    (font (get-font "-*-lucida-bold-r-normal-*-14-*-*-*-*-*-*"))
    (font-colors (list "gray60" "black"))
    
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
        (max 0 (+ 20 (min (- w-width 55) (text-width (window-name w) font)))))))
          
    (update-title-width
      (lambda (w)
        (if (eq (window-get w 'current-frame-style) 'sawmx-flipped) 
          (rebuild-frame w))))

    (button (make-image "button.png"))

    (top-left (make-image "top-left.png"))

    (title (make-image "title.png"))

    (title-right (make-image "title-right.png"))

    (top-light (make-image "top-light.png"))

    (top-right (make-image "top-right.png"))

    (left-bar (make-image "left.png"))

    (left-light (make-image "left-light.png"))

    (bottom-left (make-image "bottom-left.png"))

    (resizer (make-image "corner.png"))

    (border (make-image "border.png"))

    (d-top (make-image "d-top.png"))

    (d-top-left (make-image "d-top-left.png"))

    (d-top-right (make-image "d-top-right.png"))

    (d-left (make-image "d-left.png"))

    (d-bottom-left (make-image "d-bottom-left.png"))


    (frame `(
        ((background . ,top-left)
         (top-edge . -28)
         (left-edge . -9)
         (cursor . left_ptr)
         (class . title))
         
        ((background . ,button)
         (top-edge . -23)
         (left-edge . -4)
         (cursor . left_ptr)
         (class . iconify-button))
         
        ((background . ,title)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (top-edge . -28)
         (left-edge . 11)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . 2)
         (cursor . left_ptr)
         (class . title))

        ((background . ,title-right)
         (left-edge . ,(lambda (w) (+ (title-width w) 11)))
         (top-edge . -28)
         (cursor . left_ptr)
         (class . title))

        ((background . ,top-right)
         (right-edge . -1)
         (top-edge . -8)
         (cursor . left_ptr)
         (class . title))

        ((background . ,left-bar)
         (left-edge . ,-9)
         (top-edge . 0)
         (bottom-edge . 9)
         (cursor . left_ptr)
         (class . title))

        ((background . ,left-light)
         (left-edge . ,-6)
         (top-edge . -7)
         (bottom-edge . 9)
         (cursor . left_ptr)
         (class . title))

        ((background . ,top-light)
         (left-edge . -1)
         (right-edge . 1)
         (top-edge . -8)
         (cursor . left_ptr)
         (class . title))

        ((background . ,bottom-left)
         (left-edge . ,-9)
         (bottom-edge . -1)
         (cursor . left_ptr)
         (class . title))

        ((background . ,border)
         (left-edge . -9)
         (bottom-edge . 8)
         (width . 4)
         (cursor . left_ptr)
         (class . title))

        ((background . ,resizer)
         (right-edge . -1)
         (bottom-edge . -1)
         (cursor . left_ptr)
         (class . bottom-right-corner))

        ((background . ,border)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -1)
         (cursor . left_ptr)
         (class . bottom-border))

        ((background . ,border)
         (right-edge . -1)
         (top-edge . 0)
         (bottom-edge . 0)
         (cursor . left_ptr)
         (class . right-border))
      ))
      
    (shaped-frame `(
        ((background . ,top-left)
         (top-edge . -28)
         (left-edge . -9)
         (cursor . left_ptr)
         (class . title))
         
        ((background . ,title)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (top-edge . -28)
         (left-edge . 11)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . 2)
         (cursor . left_ptr)
         (class . title))

        ((background . ,title-right)
         (left-edge . ,(lambda (w) (+ (title-width w) 11)))
         (top-edge . -28)
         (cursor . left_ptr)
         (class . title))

        ((background . ,left-bar)
         (left-edge . -9)
         (top-edge . 0)
         (bottom-edge . 9)
         (cursor . left_ptr)
         (class . title))

        ((background . ,border)
         (left-edge . -9)
         (bottom-edge . 8)
         (width . 4)
         (cursor . left_ptr)
         (class . title))
      ))
      
      (transient-frame `(
        ((background . ,d-top-left)
         (top-edge . -5)
         (left-edge . -5)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-top)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 4)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-top-right)
         (top-edge . -5)
         (right-edge . -1)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-left)
         (top-edge . 0)
         (bottom-edge . 4)
         (left-edge . -5)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-bottom-left)
         (bottom-edge . -1)
         (left-edge . -5)
         (cursor . left_ptr)
         (class . title))

        ((background . ,border)
         (left-edge . 0)
         (right-edge . -1)
         (bottom-edge . -1)
         (cursor . left_ptr)
         (class . bottom-border))

        ((background . ,border)
         (right-edge . -1)
         (top-edge . 0)
         (bottom-edge . -1)
         (cursor . left_ptr)
         (class . right-border))
      ))
      
    (shaped-transient-frame `(
        ((background . ,d-top-left)
         (top-edge . -5)
         (left-edge . -5)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-top)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 4)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-top-right)
         (top-edge . -5)
         (right-edge . -1)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-left)
         (top-edge . 0)
         (bottom-edge . 4)
         (left-edge . -5)
         (cursor . left_ptr)
         (class . title))

        ((background . ,d-bottom-left)
         (bottom-edge . -1)
         (left-edge . -5)
         (cursor . left_ptr)
         (class . title))
      ))
    )

  (def-frame-class sawmx-button '(cursor . left_ptr)
    (bind-keys sawmx-button-keymap
      "Button1-Off" 'iconify-window)
    (bind-keys sawmx-button-keymap
      "Button3-Off" 'delete-window)
  )

    (add-frame-style 'sawmx-flipped
        (lambda (w type)
            (case type
                ((default) frame)
                ((transient) transient-frame)
                ((shaped) shaped-frame)
                ((shaped-transient) shaped-transient-frame)
    )))
            
  (call-after-property-changed 'WM_NAME update-title-width)
)
